<template>
  <b-container>
    <b-row align-h="center" class="mt-3">
      <b-col cols="5"><h1>Welcome to TODO-LIST</h1></b-col>
    </b-row>
    <b-row align-h="end">
      <b-col cols="3">
        <AddBtn @save="saveUser" />
      </b-col>
    </b-row>
    <div class="mt-4 text-center">
      <b-table-simple hover>
          <b-thead >
            <b-tr variant="dark">
              <b-th class="text-center"><h2>~~Daily-Routein~~</h2></b-th>
              <b-th class="text-center"><h2>Date&Times</h2></b-th>
              <b-th class="text-center"><h2>Edit</h2></b-th>
              <b-th class="text-center"><h2>Delete</h2></b-th>
            </b-tr>
          </b-thead> 
          <b-tbody >
            <b-tr v-for="task in tasks" :key="task.id" variant="warning ">
            <b-tr v-if="task in tasks" :key="task.id" variant="warning "></b-tr>
              <b-td>{{ task.Daily }}</b-td> 
              <b-td>{{ (task.date).replace(/T/, ' ').replace(/Z/, '').replace(/....$/, '') }}</b-td> 
              <b-td>
                
                <EditBtn
                  :id="task.id"
                  :Daily="task.Daily"
                  @edit="EditUser"
                />
              </b-td>
              <b-td><DeleteBtn :id="task.id" @delete="delUser"/></b-td>
            </b-tr>
          </b-tbody>
      </b-table-simple>
    </div>
  </b-container>
</template>
<script>
import AddBtn from "./components/AddBtn.vue";
import EditBtn from "./components/EditBtn.vue";
import DeleteBtn from "./components/DeleteBtn.vue";
import axios from "axios";


export default {
  name: "App",
  components: {
    AddBtn,
    DeleteBtn,
    EditBtn,
  },
  data() {
    return {
      tasks: [],
    };
  },
  mounted() {
    this.getData();
  },
  methods: {
    
    async getData() {
      const tasks = await axios.get("https://f325-2001-fb1-109-5714-8961-ad07-441d-33d5.ap.ngrok.io/tasks")
      // console.log(users.data.length) 
      if (tasks.status == "200") {
        this.tasks = tasks.data;
      } else {
        console.log(tasks);
      }
      return tasks
    },
    async saveUser(value) {
      await axios.post("https://f325-2001-fb1-109-5714-8961-ad07-441d-33d5.ap.ngrok.io/tasks",value)
      .then(response => 
        {
            this.getData();
            console.log(response.data)
          }
      );

    },
    async EditUser(value) {
      console.log(value)
      const tasks = await axios.put("https://f325-2001-fb1-109-5714-8961-ad07-441d-33d5.ap.ngrok.io/tasks/"+value.id,{Daily:value.p_Daily});
        console.log(tasks.data.Daily)
        console.log('success');
        this.getData();
    },

      

      
    async delUser(value) {
      console.log(value);
      const task = await axios.delete(
        "https://f325-2001-fb1-109-5714-8961-ad07-441d-33d5.ap.ngrok.io/tasks/"+value.id,
        { data: { id: value.id } }
      );
      console.log(task)

      if (task.status == "200") {
        this.getData();
       }
      },
    },
  };
</script>
